<?php

/**
 * Choix du contenu selon la langue du visiteur
 *
 * syntaxe 1 : {up lang | fr=oui | gb=yes}
 * syntaxe 2 : {up lang | lang-order=en-fr} contenu anglais {====}contenu français {/up lang}
 *
 * @author   LOMART
 * @version  UP-1.7
 * @license   <a href="http://www.gnu.org/licenses/gpl-3.0.html" target="_blank">GNU/GPLv3</a>
 * @tags    Editor
 */
defined('_JEXEC') or die;

class lang extends upAction {

    function init() {
        return true;
    }

    function run() {


        // lien vers la page de demo
        $this->set_demopage();

        $options_def = array(
          __class__ => '', // langue pour vérifer le rendu (vide en production)
          'lang-order' => 'en,fr', // ordre de saisie des langue dans contenu
          'tag' => '', // balise entourant le contenu retourné
          'class' => '', // classe(s) pour bloc
          'style' => '', // style inline pour bloc
          'id' => '',
          'css-head' => '' // règles CSS définies par le webmaster (ajout dans le head)
        );

        // On accepte toutes les options de 2 caractères. Il faut les ajouter avant contrôle
        $options_def_orig = $options_def; // on conserve une copie
        foreach (array_diff_key($this->options_user, $options_def) AS $key => $val) {
            if (strlen($key) < 3)
                $options_def[$key] = '';
        }

        // fusion et controle des options
        $options = $this->ctrl_options($options_def);

        // le code langue dans
        if ($options[__class__] == '') {
            // langue du navigateur client (la 1ere partie fr pour fr-FR, en pour en-GB)
//			$userlang = substr(JFactory::getLanguage()->getTag(), 0, 2);
            list($userlang) = explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
        } else {
            // la langue à utiliser pour tester le rendu
            $userlang = $options[__class__];
        }

        // === Recherche du contenu
        $content = ''; // valeur retour
        if ($this->content == '') {
            // les langues dans l'ordre de saisie dans le shortcode
            $lang = array_diff_key($options, $options_def_orig);
            // les traductions sont les options
            if (!empty($options[$userlang])) {
                $content = $options[$userlang];
            } else {
                // la première des langues du shortcode
                $content = reset($lang);
            }
        } else {
            $lang = explode(',', $options['lang-order']);
            $content_parts = $this->get_content_parts($this->content);
            $key = array_search($userlang, $lang);
            if ($key !== false) {
                $content = $content_parts[$key];
            } else {
                $content = $content_parts[0];
            }
        }

        // === css-head
        $this->load_css_head($options['css-head']);

        // attributs du bloc principal
        $attr_main = array();
        $attr_main['class'] = $options['class'];
        $attr_main['style'] = $options['style'];

        // code en retour
        if (($options['tag'] == '') && ($options['class'] || $options['style'])) {
            $tag = 'span';
        }
        if ($options['tag'] == '') {
            $html = $content;
        } else {
            $html = $this->set_attr_tag($options['tag'], $attr_main, $content);
        }
        return $html;
    }

// run
}

// class

